#version 430 core
/*
* Copyright 2018 Bernhard Aschl and Klemens Böswirth
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 3) in vec2 uv;
layout(location = 4) in vec3 tangent;
layout(location = 5) in vec3 bitangent;

out VertexData
{
    vec3 position_world;
    vec3 normal_world; // normalized
    vec2 uv_interpol;
	mat3 tangentToModelMatrix;
} vert;

uniform mat4 modelMatrix;
uniform mat4 transInvModelMatrix;
uniform mat4 viewProjMatrix;

void main()
{
    vert.position_world = (modelMatrix * vec4(position, 1)).xyz;
    vert.normal_world = normalize((transInvModelMatrix * vec4(normalize(normal), 1)).xyz);
	
	vert.tangentToModelMatrix = mat3(tangent, bitangent, normal);

    vert.uv_interpol = uv;

    gl_Position = viewProjMatrix * vec4(vert.position_world, 1);
}
