#version 430 core
/*
* Copyright 2018 Bernhard Aschl and Klemens Bswirth
*/

in vec3 position_interpol;
uniform sampler2D tex;

out vec4 color;
/*** Main ***/
void main() {
	color=vec4(0);
	int radius = 2;
	int amountPxNotEmpty=0;
	vec4 curFrag = texture(tex, position_interpol.xy);
	ivec2 texSize = textureSize(tex, 0);
	if(curFrag==vec4(0)){
		for(float i=-radius; i<=radius; i++)
		{
			for(float j=-radius; j<=radius; j++)
			{
				vec4 nextFrag = texture(tex, position_interpol.xy+(vec2(i,j)/texSize));
				if(nextFrag!=vec4(0)){
					amountPxNotEmpty++;
					curFrag+=nextFrag;
				}
			}
		}
	}
	color=curFrag/max(amountPxNotEmpty,1.0f);
	color.a=1;
}