#version 430 core
/*
* Copyright 2018 Bernhard Aschl and Klemens Bswirth
* source: CGUE 2018 - Steiner - Repetitorum Presentation
*/

layout (points) in;
layout (triangle_strip, max_vertices = 4) out;

uniform mat4 projectionMatrix;

out vec2 texCoord;

void main (void) {
	const vec2 size = vec2(0.1, 0.1);

	// bottom left
	gl_Position = projectionMatrix * vec4(gl_in[0].gl_Position.xy + vec2(-0.5, -0.5) * size, gl_in[0].gl_Position.zw);
	texCoord = vec2(0.0, 0.0);
	EmitVertex();

	// bottom right
	gl_Position = projectionMatrix * vec4(gl_in[0].gl_Position.xy + vec2(0.5, -0.5) * size, gl_in[0].gl_Position.zw);
	texCoord = vec2(1.0, 0.0);
	EmitVertex();

	// top left
	gl_Position = projectionMatrix * vec4(gl_in[0].gl_Position.xy + vec2(-0.5, 0.5) * size, gl_in[0].gl_Position.zw);
	texCoord = vec2(0.0, 1.0);
	EmitVertex();

	// top right
	gl_Position = projectionMatrix * vec4(gl_in[0].gl_Position.xy + vec2(0.5, 0.5) * size, gl_in[0].gl_Position.zw);
	texCoord = vec2(1.0, 1.0);
	EmitVertex();

	EndPrimitive();
}
